
#include "boggle.h"

static char bord[16];
static char used[16];
static dict *dictionary;
static char woord[17];
int verbose=0, minlen=4;

addletter(int pos, dict *dp, char *wp) {
  int i,j,newpos;
  dict *olddp;
  char ch;
  for (i=-1; i<2; i++) {
    for (j=-1; j<2; j++) {
      if (j<0 && (pos%4==0)) continue;
      if (j>0 && (pos%4==3)) continue;
      newpos=pos+(4*i)+j;
      if (newpos<0 || newpos>15) continue;
      if (used[newpos]) {
	if (verbose>0) fprintf(stderr, "pos %d used\n", newpos);
	continue;
      }
      ch=bord[newpos];
      *wp=ch;wp++;
      if (verbose>0) fprintf(stderr, "add letter from position %d -> '%s'\n", newpos, woord);
      olddp=dp;
      if (dict_lookup(&dp, ch) && strlen(woord) >= minlen) {
	printf("%s\n", woord);
      }
      used[newpos]=1;
      if (dp!=0) addletter(newpos, dp, wp);
      dp=olddp;
      used[newpos]=0;
      wp--;*wp=0;
      if (verbose>0) fprintf(stderr, "backtrack -> '%s'\n", woord);
    } 
  }  

}

main (int argc, char **argv) {
  int i,j,pos;
  char ch;
  dict *dp;
  int attrib;
  char *wp;
  extern char *optarg;
  
  while ((ch=getopt(argc, argv, "v:l:")) != -1)
    switch (ch) {
    case 'v':
      verbose=atoi(optarg);
      break;
    case 'l':
      minlen=atoi(optarg);
      break;
    default:
      fprintf(stderr, "Usage: boggle [-l(1-16)] [-v(0-2)]\n -l minimun word length\n -v verbosity level\n");
      exit (1);
    }
  /* read dictionary */
  fprintf(stderr, "reading dictionary...\n");
  dictionary=dict_open("dictionary");

  while (!feof(stdin)) {
  /* read boggle board */
  newbord:
  fprintf(stderr, "input boggle board:\n");
  for (i=0; i<4; i++) {
    for (j=0; j<4; j++) {
      ch=getc(stdin);
      if (ch<'a'||ch>'z') {
	fprintf(stderr, "Illegal character on boggle board: %c\n", ch); 
	goto newbord;
      }
      printf("%c ", ch);
      bord[i*4+j]=ch;
    }
    printf("\n");
    ch=fgetc(stdin);
    if (ch!=10) {
      fprintf(stderr, "Newline expected in input.\n"); goto newbord;
    }      
  }

  dp=dictionary;
  for (i=0; i<17; i++) woord[i]=0;
  wp=woord;

  for (pos=0; pos<16; pos++) {
    if (verbose>0) fprintf(stderr, "start from position %d\n", pos);
    dp=dictionary;
    for (i=0; i<16; i++) woord[i]=0;
    wp=woord;
    
    ch=bord[pos];
    *wp=ch;wp++;
    if (attrib=dict_lookup(&dp, ch)) {
      printf("%s", woord);
    }
    used[pos]=1;
    if (dp!=0) addletter(pos, dp, wp);
    used[pos]=0;
  }
  }
}



